<?php

namespace EventPortal\Domain\Table\Concerns;

use Illuminate\Database\Eloquent\Builder;

trait HasTable
{
    public function scopeWhereFilter(Builder $query, string $field, string $value): Builder
    {
        return $query->where("{$field}->value", $value);
    }

    public function scopeFieldsLike(Builder $query, array $columns, string $value): Builder
    {
        $query->where(function ($query) use ($value, $columns): Builder {
            collect($columns)->each(static function ($field) use ($value, $query): void {
                $query->orWhere($field, 'LIKE', "%{$value}%");
            });

            return $query;
        });

        return $query;
    }
}
